package com.xxfc.platform.order.rest;

import com.github.wxiaoqi.security.admin.feign.UserFeign;
import com.github.wxiaoqi.security.auth.client.annotation.IgnoreClientToken;
import com.github.wxiaoqi.security.common.context.BaseContextHandler;
import com.github.wxiaoqi.security.common.msg.ObjectRestResponse;
import com.github.wxiaoqi.security.common.rest.BaseController;
import com.xxfc.platform.order.biz.OrderActivityInfoDetailBiz;
import com.xxfc.platform.order.contant.enumerate.OrderTypeEnum;
import com.xxfc.platform.order.entity.BaseOrder;
import com.xxfc.platform.order.entity.OrderActivityDetail;
import com.xxfc.platform.order.pojo.dto.ActivityOrderFindDTO;
import com.xxfc.platform.order.pojo.order.ActivityInfoBO;
import com.xxfc.platform.order.service.OrderActivityInfoService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("tainde/orderActivity")
@Api(value = "活动订单", tags = {"活动订单"})
public class OrderActivityInfoController extends BaseController<OrderActivityInfoDetailBiz, OrderActivityDetail> {

    @Autowired
    OrderActivityInfoService activityInfoService;

    @Autowired
    UserFeign userFeign;

    @RequestMapping(value = "add", method = RequestMethod.POST)
    @ApiOperation(value = "确认订单")
    @IgnoreClientToken
    public ObjectRestResponse<BaseOrder> add(@RequestBody ActivityInfoBO bo) {
        bo.setAppUserDTO(userFeign.userDetailByToken(BaseContextHandler.getToken()).getData());
        activityInfoService.createOrder(bo);
        return ObjectRestResponse.succ(bo.getOrder());
    }


    @GetMapping(value = "selectList")
    public ObjectRestResponse selectList(ActivityOrderFindDTO activityOrderFindDTO) {
        activityOrderFindDTO.setType(OrderTypeEnum.ACTIVITY.getCode());
        return ObjectRestResponse.succ(baseBiz.selectList(activityOrderFindDTO));
    }

    @GetMapping(value = "selectListStatic")
    public ObjectRestResponse selectListStatic(ActivityOrderFindDTO activityOrderFindDTO) {
        activityOrderFindDTO.setType(OrderTypeEnum.ACTIVITY.getCode());
        return ObjectRestResponse.succ(baseBiz.selectListStatic(activityOrderFindDTO));
    }
}